//::///////////////////////////////////////////////
//:: Name       MICS Config File
//:: FileName   asg_cfg_mics
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*

    This is the options file for the ASG MICS
    project.

*/
//:://////////////////////////////////////////////
//:: Created By:    Donny Wilbanks
//:: Created On:    4/26/03
//:://////////////////////////////////////////////


// Set Price for Items

void main()
{
    // Item Level
    int iLevel_1,iLevel_2,iLevel_3,iLevel_4,iLevel_5,iLevel_6,iLevel_7,iLevel_8;
    int iLevel_9,iLevel_10,iLevel_11,iLevel_12,iLevel_13,iLevel_14,iLevel_15;
    int iLevel_16,iLevel_17,iLevel_18,iLevel_19,iLevel_20,iLevel_Plus;
    // Scroll & Potion Level
    int iLevel_p1,iLevel_p2,iLevel_p3,iLevel_p4,iLevel_p5,iLevel_p6,iLevel_p7,iLevel_p8;
    int iLevel_p9,iLevel_p10,iLevel_p11,iLevel_p12,iLevel_p13,iLevel_p14,iLevel_p15;
    int iLevel_p16,iLevel_p17,iLevel_p18,iLevel_p19,iLevel_p20,iLevel_pPlus;
    int rMISC_COPYOBJECT;
    int rMICS_XPCOST;
    float rMICS_MATERIALCOST;
    int rMISC_BUILDTIME;
    // ***************************
    // **
    // ** Material Cost
    // **
    // ** Standard Material Cost is equal to 1/2 the Base Gold Peice Cost of the
    // ** item being made.
    rMICS_MATERIALCOST = 0.5;
    // ***************************
    // **
    // ** XP Cost
    // **
    // ** Standard 3e rules throws out the XP cost at 1/25 the cost of the
    // ** material cost. You may change that here.
    rMICS_XPCOST = 25;
    // ***************************
    // **
    // ** CopyObject
    // **
    // ** This works by copying the object in the Item List Chest to the players
    // ** inventory. Advantages to this is that you can make a number of
    // ** modifications to the item without changing the blueprint and having to
    // ** make a new item resref. Draw back is that many scripts that deal with
    // ** inventory destroy & recreate the item. If this happens with a modified
    // ** item that has been copied, it will return to it's original resref.
    rMISC_COPYOBJECT = FALSE;
    // ***************************
    // **
    // ** Build Time
    // **
    // ** Some DM's may wish to limit how often a player can build a new item
    // ** this time is expressesd in game hours. Defualt is 0;
    rMISC_BUILDTIME = 1;
    // ***************************
    // **
    // ** Item Level Build Restriction -
    // **
    // ** Not happy with level restriction I placed on the build item requirement
    // ** you can change that here. Each iLevel_X represents a character level
    // ** with that particular class. Just Change the Number and that will change
    // ** the gp value and level. Note there is a seperate Price List for
    // ** Scrolls & Potions.
    // *** Level 1
    iLevel_1 = 1000;
    // *** Level 2
    iLevel_2 = 1500;
    // *** Level 3
    iLevel_3 = 2500;
    // *** Level 4
    iLevel_4 = 3500;
    // *** Level 5
    iLevel_5 = 5000;
    // *** Level 6
    iLevel_6 = 6500;
    // *** Level 7
    iLevel_7 = 9000;
    // *** Level 8
    iLevel_8 = 12000;
    // *** Level 9
    iLevel_9 = 15000;
    // *** Level 10
    iLevel_10 = 19500;
    // *** Level 11
    iLevel_11 = 25000;
    // *** Level 12
    iLevel_12 = 30000;
    // *** Level 13
    iLevel_13 = 35000;
    // *** Level 14
    iLevel_14 = 40000;
    // *** Level 15
    iLevel_15 = 50000;
    // *** Level 16
    iLevel_16 = 65000;
    // *** Level 17
    iLevel_17 = 75000;
    // *** Level 18
    iLevel_18 = 90000;
    // *** Level 19
    iLevel_19 = 110000;
    // *** Level 20
    iLevel_20 = 130000;
    // *** Over 20th level - 1 level for each (iLevel_Plus) over 20+
    // *** how is this possible? See The Enchanted Anvil & Holy Alter for detials.
    iLevel_Plus = 20000;
    // ***************************
    // **
    // ** Scroll & Potion Level Build Restriction -
    // **
    // ** Not happy with level restrictio I placed on the build item requirement
    // ** you can change that here. Each iLevel_pX represents a character level
    // ** with that particular class. Just Change the Number and that will change
    // ** the gp value and level.
    // *** Level 1
    iLevel_p1 = 40;
    // *** Level 2
    iLevel_p2 = 80;
    // *** Level 3
    iLevel_p3 = 120;
    // *** Level 4
    iLevel_p4 = 210;
    // *** Level 5
    iLevel_p5 = 300;
    // *** Level 6
    iLevel_p6 = 430;
    // *** Level 7
    iLevel_p7 = 560;
    // *** Level 8
    iLevel_p8 = 730;
    // *** Level 9
    iLevel_p9 = 900;
    // *** Level 10
    iLevel_p10 = 1110;
    // *** Level 11
    iLevel_p11 = 1320;
    // *** Level 12
    iLevel_p12 = 1570;
    // *** Level 13
    iLevel_p13 = 1821;
    // *** Level 14
    iLevel_p14 = 2111;
    // *** Level 15
    iLevel_p15 = 2401;
    // *** Level 16
    iLevel_p16 = 2731;
    // *** Level 17
    iLevel_p17 = 3061;
    // *** Level 18
    iLevel_p18 = 3411;
    // *** Level 19
    iLevel_p19 = 3761;
    // *** Level 20
    iLevel_p20 = 4111;
    // *** Over 20th level - 1 level for each (iLevel_Plus) over 20+
    // *** how is this possible? See The Enchanted Anvil & Holy Alter for detials.
    iLevel_pPlus = 500;
    // ************************************************************************
    // **
    // ** Store Varibles to Mod.
    // **
    SetLocalInt(GetModule(),"ASG_MICS_COPYOBJECT",rMISC_COPYOBJECT);
    SetLocalFloat(GetModule(),"ASG_MICS_MATERIALCOST",rMICS_MATERIALCOST);
    SetLocalInt(GetModule(),"ASG_MICS_XPCOST",rMICS_XPCOST);
    SetLocalInt(GetModule(),"ASG_MICS_BUILDTIME",rMISC_BUILDTIME);
    // ** Store Item Level Restrictions
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_1",iLevel_1);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_2",iLevel_2);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_3",iLevel_3);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_4",iLevel_4);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_5",iLevel_5);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_6",iLevel_6);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_7",iLevel_7);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_8",iLevel_8);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_9",iLevel_9);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_10",iLevel_10);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_11",iLevel_11);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_12",iLevel_12);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_13",iLevel_13);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_14",iLevel_14);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_15",iLevel_15);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_16",iLevel_16);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_17",iLevel_17);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_18",iLevel_18);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_19",iLevel_19);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_20",iLevel_20);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_Plus",iLevel_Plus);
    // Set Potion & Scroll Level Restrictions
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p1",iLevel_p1);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p2",iLevel_p2);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p3",iLevel_p3);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p4",iLevel_p4);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p5",iLevel_p5);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p6",iLevel_p6);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p7",iLevel_p7);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p8",iLevel_p8);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p9",iLevel_p9);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p10",iLevel_p10);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p11",iLevel_p11);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p12",iLevel_p12);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p13",iLevel_p13);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p14",iLevel_p14);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p15",iLevel_p15);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p16",iLevel_p16);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p17",iLevel_p17);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p18",iLevel_p18);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p19",iLevel_p19);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_p20",iLevel_p20);
    SetLocalInt(GetModule(),"ASG_MICS_ITEM_LEVEL_pPlus",iLevel_pPlus);

    // Attempt to Scatter Books Across the Mod
    ExecuteScript("asg_rseedbooks",GetModule());

}

