#include "x0_i0_spawncond"
#include "give_custom_exp"

void main()
{
    int nClass = GetLevelByClass(CLASS_TYPE_COMMONER);
    int nAlign = GetAlignmentGoodEvil(OBJECT_SELF);

    // If we're a good/neutral commoner,
    // adjust the killer's alignment evil
    if(nClass > 0 && (nAlign == ALIGNMENT_GOOD || nAlign == ALIGNMENT_NEUTRAL))
    {
        object oKiller = GetLastKiller();
        AdjustAlignment(oKiller, ALIGNMENT_EVIL, 5);
    }

    // Call to allies to let them know we're dead
    SpeakString("NW_I_AM_DEAD", TALKVOLUME_SILENT_TALK);

    //Shout Attack my target, only works with the On Spawn In setup
    SpeakString("NW_ATTACK_MY_TARGET", TALKVOLUME_SILENT_TALK);

    // NOTE: the OnDeath user-defined event does not
    // trigger reliably and should probably be removed
    if(GetSpawnInCondition(NW_FLAG_DEATH_EVENT))
    {
         SignalEvent(OBJECT_SELF, EventUserDefined(1007));
    }



//////////////////////////////////////////////////////////
    if( !GetIsPC( OBJECT_SELF ) )
      give_custom_exp( GetLastKiller(), OBJECT_SELF, 0 );

//////////////////////////////////////////////////////////
//Put this OnDeath


object oPC = GetLastKiller();

while (GetIsObjectValid(oPC) && !GetIsPC(GetMaster(oPC)))
   {
   oPC=GetMaster(oPC);
   }

location lTarget = GetLocation(OBJECT_SELF);
object oSpawn = CreateObject(OBJECT_TYPE_CREATURE, "angrydruid", lTarget);

DelayCommand(0.5, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(VFX_FNF_NATURES_BALANCE), lTarget));
DelayCommand(1.0, AssignCommand(oSpawn, ActionStartConversation(oPC, "angrydruid")));

ExecuteScript("prc_npc_death", OBJECT_SELF);

}

