//::///////////////////////////////////////////////
//:: Default: On Spawn In
//:: NW_C2_DEFAULT9
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Determines the course of action to be taken
    after having just been spawned in
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 25, 2001
//:://////////////////////////////////////////////
#include "nw_i0_spells"
#include "ms_name_inc"
#include "rnd_commoner_inc"
#include "NW_O2_CONINCLUDE"
#include "NW_I0_GENERIC"

void main()
{
// Randomize Skin Tone
    rnd_skin(OBJECT_SELF);

// Randomize Head & Hair color
    rnd_head(OBJECT_SELF);

// Randomize Tattoos
    rnd_tattoo(OBJECT_SELF);

// Randomize Clothing
    rnd_clothes(OBJECT_SELF);

// Randomize Last Name Usage
    int bNameChance = d100() > 33;
    SetLocalInt(OBJECT_SELF, "NAME_TYPE", bNameChance);

    int nOneName = GetLocalInt(OBJECT_SELF,"SINGLE_NAME");
        if (nOneName = 1)
            {
                    SetLocalInt(OBJECT_SELF, "NAME_TYPE", 0);
            }

//Calls the Random Name Generator
    ms_Nomenclature(OBJECT_SELF);

// OPTIONAL BEHAVIORS (Comment In or Out to Activate )****************************************************************************
     //SetSpawnInCondition(NW_FLAG_SPECIAL_CONVERSATION);
     //SetSpawnInCondition(NW_FLAG_SPECIAL_COMBAT_CONVERSATION);
                // This causes the creature to say a special greeting in their conversation file
                // upon Perceiving the player. Attach the [NW_D2_GenCheck.nss] script to the desired
                // greeting in order to designate it. As the creature is actually saying this to
                // himself, don't attach any player responses to the greeting.

     //SetSpawnInCondition(NW_FLAG_SHOUT_ATTACK_MY_TARGET);
                // This will set the listening pattern on the NPC to attack when allies call
     //SetSpawnInCondition(NW_FLAG_STEALTH);
                // If the NPC has stealth and they are a rogue go into stealth mode
     //SetSpawnInCondition(NW_FLAG_SEARCH);
                // If the NPC has Search go into Search Mode
     //SetSpawnInCondition(NW_FLAG_SET_WARNINGS);
                // This will set the NPC to give a warning to non-enemies before attacking

     //SetSpawnInCondition(NW_FLAG_SLEEP);
                //Creatures that spawn in during the night will be asleep.
     //SetSpawnInCondition(NW_FLAG_DAY_NIGHT_POSTING);
     //SetSpawnInCondition(NW_FLAG_APPEAR_SPAWN_IN_ANIMATION);
     //SetSpawnInCondition(NW_FLAG_IMMOBILE_AMBIENT_ANIMATIONS);

     SetSpawnInCondition(NW_FLAG_AMBIENT_ANIMATIONS);
                //This will play Ambient Animations until the NPC sees an enemy or is cleared.
                //NOTE that these animations will play automatically for Encounter Creatures.

     SetAnimationCondition(NW_ANIM_FLAG_IS_CIVILIZED);
        // Interacts with placeables + More civilized actions. See Readme.

     //SetAnimationCondition(NW_ANIM_FLAG_CHATTER);
        // Will use random voicechats during animations, if Civilized

    // NOTE: ONLY ONE OF THE FOLOOWING ESCAPE COMMANDS SHOULD EVER BE ACTIVATED AT ANY ONE TIME.
    //SetSpawnInCondition(NW_FLAG_ESCAPE_RETURN);    // OPTIONAL BEHAVIOR (Flee to a way point and return a short time later.)
    //SetSpawnInCondition(NW_FLAG_ESCAPE_LEAVE);     // OPTIONAL BEHAVIOR (Flee to a way point and do not return.)
    //SetSpawnInCondition(NW_FLAG_TELEPORT_LEAVE);   // OPTIONAL BEHAVIOR (Teleport to safety and do not return.)
    //SetSpawnInCondition(NW_FLAG_TELEPORT_RETURN);  // OPTIONAL BEHAVIOR (Teleport to safety and return a short time later.)

// CUSTOM USER DEFINED EVENTS
/*
    The following settings will allow the user to fire one of the blank user defined events in the NW_D2_DefaultD.  Like the
    On Spawn In script this script is meant to be customized by the end user to allow for unique behaviors.  The user defined
    events user 1000 - 1010
*/
    //SetSpawnInCondition(NW_FLAG_HEARTBEAT_EVENT);        //OPTIONAL BEHAVIOR - Fire User Defined Event 1001
    //SetSpawnInCondition(NW_FLAG_PERCIEVE_EVENT);         //OPTIONAL BEHAVIOR - Fire User Defined Event 1002
    //SetSpawnInCondition(NW_FLAG_ATTACK_EVENT);           //OPTIONAL BEHAVIOR - Fire User Defined Event 1005
    //SetSpawnInCondition(NW_FLAG_DAMAGED_EVENT);          //OPTIONAL BEHAVIOR - Fire User Defined Event 1006
    //SetSpawnInCondition(NW_FLAG_DISTURBED_EVENT);        //OPTIONAL BEHAVIOR - Fire User Defined Event 1008
    //SetSpawnInCondition(NW_FLAG_END_COMBAT_ROUND_EVENT); //OPTIONAL BEHAVIOR - Fire User Defined Event 1003
    //SetSpawnInCondition(NW_FLAG_ON_DIALOGUE_EVENT);      //OPTIONAL BEHAVIOR - Fire User Defined Event 1004
    //SetSpawnInCondition(NW_FLAG_DEATH_EVENT);            //OPTIONAL BEHAVIOR - Fire User Defined Event 1007

// DEFAULT GENERIC BEHAVIOR (DO NOT TOUCH) *****************************************************************************************

    SetLocalInt(OBJECT_SELF, "iDialogue", Random(10) + 1);

    SetLocalInt(OBJECT_SELF, "iRumor", Random(13) + 1);

    SetListeningPatterns();    // Goes through and sets up which shouts the NPC will listen to.
    //WalkWayPoints();           // Optional Parameter: void WalkWayPoints(int nRun = FALSE, float fPause = 1.0)
                               // 1. Looks to see if any Way Points in the module have the tag "WP_" + NPC TAG + "_0X", if so walk them
                               // 2. If the tag of the Way Point is "POST_" + NPC TAG the creature will return this way point after
                               //    combat.
    GenerateNPCTreasure();     //* Use this to create a small amount of treasure on the creature

    ClearAllActions();
          SetAILevel (OBJECT_SELF, AI_LEVEL_HIGH);
          string sMyTagName = GetTag(OBJECT_SELF);
          string sSittableTagName = "CHAIR_" + sMyTagName;
          object oChair = GetRandomObjectByTag(sSittableTagName, 100.0);
          DelayCommand(60.0, ActionForceMoveToObject (oChair, FALSE, 1.0f, 120.0f));
          DelayCommand(60.1, ActionSit(oChair));
    int nTime = Random(200) + 90;
    float fTime = IntToFloat(nTime);
    DelayCommand(fTime, ExecuteScript("npc_sit_stay", OBJECT_SELF));
}


