//
// Spawn Effect
//
int ParseFlagValue(string sName, string sFlag, int nDigits, int nDefault);
int ParseSubFlagValue(string sName, string sFlag, int nDigits, string sSubFlag, int nSubDigits, int nDefault);
object GetChildByTag(object oSpawn, string sChildTag);
object GetChildByNumber(object oSpawn, int nChildNum);
object GetSpawnByID(int nSpawnID);
void DeactivateSpawn(object oSpawn);
void DeactivateSpawnsByTag(string sSpawnTag);
void DeactivateAllSpawns();
void DespawnChildren(object oSpawn);
void DespawnChildrenByTag(object oSpawn, string sSpawnTag);
//
//
int SpawnEffect(object oSpawn, int nSpawnEffect, int nDespawnEffect)
{
    // Initialize
    int nEffect;
    int nEffectNumber;

    // Initialize Values
    if (nSpawnEffect == TRUE)
    {
        nEffectNumber = GetLocalInt(oSpawn, "f_SpawnEffect");
    }
    else if (nDespawnEffect == TRUE)
    {
        nEffectNumber = GetLocalInt(oSpawn, "f_DespawnEffect");
    }

//
// Only Make Modifications Between These Lines
// -------------------------------------------


    // Effect 00
    // Dummy Effect - Never Use
    if (nEffectNumber == 0)
    {
        return nEffect;
    }
    //

    // Rotting Corpse Spawn/Despawn
    if (nEffectNumber == 51)
    {
        nEffect = VFX_IMP_DISEASE_S;
    }
    //


// -------------------------------------------
// Only Make Modifications Between These Lines
//

    // Return the Effect
    return nEffect;
}

/*
18 - VFX_FNF_BLINDDEAF
19 - VFX_FNF_DISPEL
20 - VFX_FNF_DISPEL_DISJUNCTION
21 - VFX_FNF_DISPEL_GREATER
22 - VFX_FNF_FIREBALL
23 - VFX_FNF_FIRESTORM
24 - VFX_FNF_IMPLOSION
26 - VFX_FNF_MASS_HEAL
27 - VFX_FNF_MASS_MIND_AFFECTING
28 - VFX_FNF_METEOR_SWARM
29 - VFX_FNF_NATURES_BALANCE
30 - VFX_FNF_PWKILL
31 - VFX_FNF_PWSTUN
32 - VFX_FNF_SUMMON_GATE
33 - VFX_FNF_SUMMON_MONSTER_1
34 - VFX_FNF_SUMMON_MONSTER_2
35 - VFX_FNF_SUMMON_MONSTER_3
36 - VFX_FNF_SUMMON_UNDEAD
37 - VFX_FNF_SUNBEAM
38 - VFX_FNF_TIME_STOP
39 - VFX_FNF_WAIL_O_BANSHEES
40 - VFX_FNF_WEIRD
41 - VFX_FNF_WORD
42 - VFX_IMP_AC_BONUS
43 - VFX_IMP_ACID_L
44 - VFX_IMP_ACID_S
46 - VFX_IMP_BLIND_DEAF_M
47 - VFX_IMP_BREACH
48 - VFX_IMP_CONFUSION_S
49 - VFX_IMP_DAZED_S
50 - VFX_IMP_DEATH
51 - VFX_IMP_DISEASE_S
52 - VFX_IMP_DISPEL
53 - VFX_IMP_DISPEL_DISJUNCTION
54 - VFX_IMP_DIVINE_STRIKE_FIRE
55 - VFX_IMP_DIVINE_STRIKE_HOLY
56 - VFX_IMP_DOMINATE_S
57 - VFX_IMP_DOOM
58 - VFX_IMP_FEAR_S
60 - VFX_IMP_FLAME_M
61 - VFX_IMP_FLAME_S
62 - VFX_IMP_FROST_L
63 - VFX_IMP_FROST_S
64 - VFX_IMP_GREASE
65 - VFX_IMP_HASTE
66 - VFX_IMP_HEALING_G
67 - VFX_IMP_HEALING_L
68 - VFX_IMP_HEALING_M
69 - VFX_IMP_HEALING_S
70 - VFX_IMP_HEALING_X
71 - VFX_IMP_HOLY_AID
72 - VFX_IMP_KNOCK
74 - VFX_IMP_LIGHTNING_M
75 - VFX_IMP_LIGHTNING_S
76 - VFX_IMP_MAGBLUE
81 - VFX_IMP_NEGATIVE_ENERGY
83 - VFX_IMP_POISON_L
84 - VFX_IMP_POISON_S
85 - VFX_IMP_POLYMORPH
86 - VFX_IMP_PULSE_COLD
87 - VFX_IMP_PULSE_FIRE
88 - VFX_IMP_PULSE_HOLY
89 - VFX_IMP_PULSE_NEGATIVE
90 - VFX_IMP_RAISE_DEAD
91 - VFX_IMP_REDUCE_ABILITY_SCORE
92 - VFX_IMP_REMOVE_CONDITION
93 - VFX_IMP_SILENCE
94 - VFX_IMP_SLEEP
95 - VFX_IMP_SLOW
96 - VFX_IMP_SONIC
97 - VFX_IMP_STUN
98 - VFX_IMP_SUNSTRIKE
99 - VFX_IMP_UNSUMMON
100 - VFX_COM_SPECIAL_BLUE_RED
101 - VFX_COM_SPECIAL_PINK_ORANGE
102 - VFX_COM_SPECIAL_RED_WHITE
103 - VFX_COM_SPECIAL_RED_ORANGE
104 - VFX_COM_SPECIAL_WHITE_BLUE
105 - VFX_COM_SPECIAL_WHITE_ORANGE
106 - VFX_COM_BLOOD_REG_WIMP
107 - VFX_COM_BLOOD_LRG_WIMP
108 - VFX_COM_BLOOD_CRT_WIMP
109 - VFX_COM_BLOOD_REG_RED
110 - VFX_COM_BLOOD_REG_GREEN
111 - VFX_COM_BLOOD_REG_YELLOW
112 - VFX_COM_BLOOD_LRG_RED
113 - VFX_COM_BLOOD_LRG_GREEN
114 - VFX_COM_BLOOD_LRG_YELLOW
115 - VFX_COM_BLOOD_CRT_RED
116 - VFX_COM_BLOOD_CRT_GREEN
117 - VFX_COM_BLOOD_CRT_YELLOW
118 - FX_COM_SPARKS_PARRY
120 - VFX_COM_UNLOAD_MODEL
121 - VFX_COM_CHUNK_RED_SMALL
122 - VFX_COM_CHUNK_RED_MEDIUM
123 - VFX_COM_CHUNK_GREEN_SMALL
124 - VFX_COM_CHUNK_GREEN_MEDIUM
125 - VFX_COM_CHUNK_YELLOW_SMALL
126 - VFX_COM_CHUNK_YELLOW_MEDIUM
139 - VFX_IMP_IMPROVE_ABILITY_SCORE
140 - VFX_IMP_CHARM
141 - VFX_IMP_MAGICAL_VISION
144 - VFX_IMP_EVIL_HELP
145 - VFX_IMP_GOOD_HELP
146 - VFX_IMP_DEATH_WARD
149 - VFX_IMP_MAGIC_PROTECTION
150 - VFX_IMP_SUPER_HEROISM
151 - VFX_FNF_STORM
152 - VFX_IMP_ELEMENTAL_PROTECTION
181 - VFX_IMP_MIRV
183 - VFX_FNF_SOUND_BURST
184 - VFX_FNF_STRIKE_HOLY
185 - VFX_FNF_LOS_EVIL_10
186 - VFX_FNF_LOS_EVIL_20
187 - VFX_FNF_LOS_EVIL_30
188 - VFX_FNF_LOS_HOLY_10
189 - VFX_FNF_LOS_HOLY_20
190 - VFX_FNF_LOS_HOLY_30
191 - VFX_FNF_LOS_NORMAL_10
192 - VFX_FNF_LOS_NORMAL_20
193 - VFX_FNF_LOS_NORMAL_30
194 - VFX_IMP_HEAD_ACID
195 - VFX_IMP_HEAD_FIRE
196 - VFX_IMP_HEAD_SONIC
197 - VFX_IMP_HEAD_ELECTRICITY
198 - VFX_IMP_HEAD_COLD
199 - VFX_IMP_HEAD_HOLY
200 - VFX_IMP_HEAD_NATURE
201 - VFX_IMP_HEAD_HEAL
202 - VFX_IMP_HEAD_MIND
203 - VFX_IMP_HEAD_EVIL
204 - VFX_IMP_HEAD_ODD
217 - VFX_IMP_DEATH_L
219 - VFX_FNF_SUMMON_CELESTIAL
221 - VFX_IMP_RESTORATION_LESSER
222 - VFX_IMP_RESTORATION
223 - VFX_IMP_RESTORATION_GREATER
231 - VFX_FNF_ICESTORM
233 - VFX_IMP_MIRV_FLAME
234 - VFX_IMP_DESTRUCTION
235 - VFX_COM_CHUNK_RED_LARGE
236 - VFX_COM_CHUNK_BONE_MEDIUM
237 - VFX_COM_BLOOD_SPARK_SMALL
238 - VFX_COM_BLOOD_SPARK_MEDIUM
239 - VFX_COM_BLOOD_SPARK_LARGE
241 - VFX_FNF_HORRID_WILTING
246 - VFX_IMP_HARM
250 - VFX_IMP_MAGIC_RESISTANCE_USE
251 - VFX_IMP_GLOBE_USE
252 - VFX_IMP_WILL_SAVING_THROW_USE
253 - VFX_IMP_SPIKE_TRAP
254 - VFX_IMP_SPELL_MANTLE_USE
255 - VFX_IMP_FORTITUDE_SAVING_THROW_USE
256 - VFX_IMP_REFLEX_SAVE_THROW_USE
257 - VFX_FNF_GAS_EXPLOSION_ACID
258 - VFX_FNF_GAS_EXPLOSION_EVIL
259 - VFX_FNF_GAS_EXPLOSION_NATURE
260 - VFX_FNF_GAS_EXPLOSION_FIRE
261 - VFX_FNF_GAS_EXPLOSION_GREASE
262 - VFX_FNF_GAS_EXPLOSION_MIND
263 - VFX_FNF_SMOKE_PUFF
264 - VFX_IMP_PULSE_WATER
265 - VFX_IMP_PULSE_WIND
266 - VFX_IMP_PULSE_NATURE
273 - VFX_IMP_AURA_HOLY
274 - VFX_IMP_AURA_UNEARTHLY
275 - VFX_IMP_AURA_FEAR
276 - VFX_IMP_AURA_NEGATIVE_ENERGY
278 - VFX_FNF_HOWL_MIND
279 - VFX_FNF_HOWL_ODD
280 - VFX_COM_HIT_FIRE
281 - VFX_COM_HIT_FROST
282 - VFX_COM_HIT_ELECTRICAL
283 - VFX_COM_HIT_ACID
284 - VFX_COM_HIT_SONIC
285 - VFX_FNF_HOWL_WAR_CRY
286 - VFX_FNF_SCREEN_SHAKE
287 - VFX_FNF_SCREEN_BUMP
288 - VFX_COM_HIT_NEGATIVE
289 - VFX_COM_HIT_DIVINE
290 - VFX_FNF_HOWL_WAR_CRY_FEMALE
*/
